var Communication = require('./communication')
var communicate = new Communication()

var requestQueue = function() {
    this.communicate = function(queue) {
        return new Promise(function(resolve, reject) {
            var promises = []
            var returnDocuments = {}
            for (const key in queue) {
                switch(queue[key].method) {
                    case 'GET':     promises.push(communicate.sendGETRequest(key, queue[key])); break
                    case 'POST':    promises.push(communicate.sendPOSTRequest(key, queue[key])); break
                    default: throw new Error('method must be GET or POST ...')
                }       
            }
            Promise.all(promises).then(documents => {
                documents.forEach(document => {
                    returnDocuments[document.key] = document
                    delete document.key
                })
                resolve(returnDocuments)
            }).catch(err => {reject(err)})
        })
    }
}

module.exports = requestQueue